package cz.muni.fi.pb138.xpathdemo;

import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * ***********************************************************************
 * Take this skeleton code and implement the missing bodies of
 * <code>averageSalaryAtDivision</code> and <code>addNote</code> methods.
 * Everything else should be left untouched.<br/>
 *
 * After completion, the <code>main</code> method should work correctly.<br/>
 * It reads (parses) the given file (company.xml if you run it directly from the
 * Netbeans project) and processes it using your methods.
 *
 */
public class Main {

    private static final String COMPANYXML = "company.xml";
    public static final String FIRSTNOTE = "//person[@pid='1']/note[1]";
    public static final String SECONDNOTE = "//person[@pid='1']/note[2]";
    private static final String SALARY_SUM_BRNO = "sum(//division[@did='development_brno']//salary)";
    private static final String PERSON_COUNT_BRNO = "count(//division[@did='development_brno']//person)";
    private static final String SALARY_SUM_ZLIN = "sum(//division[@did='production_zlin']//salary)";
    private static final String PERSON_COUNT_ZLIN = "count(//division[@did='production_zlin']//person)";

    private static final double DELTA = 0.001;
    /**
     * W3C object model representation of a XML document. Note: We use the
     * interface(!) not its implementation
     */
    private Document doc;
    private XPath xpath;

    private Main(URI uri) throws SAXException, ParserConfigurationException,
            IOException {
        // Vytvorime instanci tovarni tridy
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci DocumentBuilderu
        DocumentBuilder builder = factory.newDocumentBuilder();
        // DocumentBuilder pouzijeme pro zpracovani XML dokumentu
        // a ziskame model dokumentu ve formatu W3C DOM
        doc = builder.parse(uri.toString());
        xpath = XPathFactory.newInstance().newXPath();

    }

    public void serializetoXML(URI output)
            throws IOException, TransformerConfigurationException, TransformerException {
        // Vytvorime instanci tovarni tridy
        TransformerFactory factory = TransformerFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci tzv. kopirovaciho transformeru
        Transformer transformer = factory.newTransformer();
        // Vstupem transformace bude dokument v pameti
        DOMSource source = new DOMSource(doc);
        // Vystupem transformace bude vystupni soubor
        StreamResult result = new StreamResult(output.toString());
        // Provedeme transformaci
        transformer.transform(source, result);
    }

    public void serializetoXML(File output) throws IOException,
            TransformerException {
        serializetoXML(output.toURI());
    }

    public static void main(String[] args) throws IOException, SAXException, ParserConfigurationException, TransformerException, URISyntaxException, XPathExpressionException {

        URI uri = Main.class.getResource(COMPANYXML).toURI();
        if (uri == null) {
            throw new IOException("The XML file for testing cannot be found.");
        }
        Main solution = new Main(uri);
        solution.avgDemo();
        solution.xpath20Demo();
    }

    private void avgDemo() throws XPathExpressionException {
        double avg1 = (Double) xpath.evaluate(
                SALARY_SUM_BRNO, doc, XPathConstants.NUMBER)
                / (Double) xpath.evaluate(
                        PERSON_COUNT_BRNO, doc, XPathConstants.NUMBER);
        System.out.println("Average salary = " + avg1);
    }
    
    private void xpath20Demo() throws XPathExpressionException {
        double sum = (double) xpath.evaluate(
                "sum(//person/salary)", 
                doc, XPathConstants.NUMBER);
        System.out.println("Sum of id*salary for all persons = " + sum);
    }
}
